package servlet;


import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.ejb.CreateException;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.*;
import java.util.*;
import com.sun.appserv.jdbc.*;
import javax.transaction.UserTransaction;

public class SimpleServlet extends HttpServlet {


    public void doGet (HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
      doPost(request, response);
    }

    /** handles the HTTP POST operation **/
    public void doPost (HttpServletRequest request,HttpServletResponse response)
          throws ServletException, IOException {
        doTest(request, response);
    }

    public void doTest(HttpServletRequest request, HttpServletResponse response) throws IOException{
        PrintWriter out = response.getWriter();

        try{
InitialContext ctx= new InitialContext();
UserTransaction tx = (UserTransaction) ctx.lookup("java:comp/UserTransaction");
tx.begin();
DataSource ds = (com.sun.appserv.jdbc.DataSource) ctx.lookup("java:comp/env/DataSourceNoShare");
Connection conn1 = ds.getConnection();
Connection physicalConn1 = ds.getConnection(conn1);
Connection conn2 = ds.getConnection();
Connection physicalConn2 = ds.getConnection(conn2);
Set<Connection> physicalConnections = new HashSet<Connection>();
physicalConnections.add(physicalConn1);
physicalConnections.add(physicalConn2);
System.out.println("the size of physicalConnections is " + physicalConnections.size());
if(physicalConnections.size() == 1){
System.out.println("Connection Sharing test : connSharingTest : FAIL");
            out.println("TEST:FAIL");

}
tx.commit();

conn1.close();
conn2.close();
	} catch(NamingException ne) {
	    ne.printStackTrace();
	} catch(Exception e) {
            System.out.println("Connection Sharing test : connSharingTest : PASS");
            out.println("TEST:PASS");
	    e.printStackTrace();
        } finally {
	    out.println("END_OF_TEST");
	    out.flush();
	}
    }
}
